#include<iostream>
#include<cmath>
using namespace std;
int main ()
{
    int S, N;
    cin>>S>>N;
    int mas[N];
    for (int i=0; i<N; i++){
        cin>>mas[i];
    }
    for (int i=0; i<N-1; i++){
        for (int q=0; q<N-1-i; q++){
            if (mas[q]<mas[q+1]){
                swap (mas[q], mas[q+1]);
            }
        }
    }
    long long br=0;
    for (int i=0; i<N; i++)
    {
        while (mas[i]<=S){
            S=S-mas[i];
            br++;
        }
    }
    cout<<br;
    return 0;
}
